%define cscope_share_path %{_datadir}/cscope
%define emacs_lisp_path %{_datadir}/emacs/site-lisp
%define vim_plugin_path %{_datadir}/vim/vimfiles/plugin

Summary:   C source code tree search and browse tool
Name:      cscope
Version:   15.9
Release:   6%{?dist}
License:   BSD and GPLv2+
URL:       http://cscope.sourceforge.net
Source0:   https://downloads.sourceforge.net/project/%{name}/%{name}/v%{version}/%{name}-%{version}.tar.gz

Patch3000: cscope-1-modified-from-patch-81-Fix-reading-include-files-in-.patch
Patch3001: cscope-2-Cull-extraneous-declaration.patch
Patch3002: cscope-3-Avoid-putting-directories-found-during-header-search.patch
Patch3003: cscope-4-Avoid-double-free-via-double-fclose-in-changestring.patch
Patch3004: cscope-5-contrib-ocs-Fix-bashims-Closes-480591.patch
Patch3005: cscope-6-doc-cscope.1-Fix-hyphens.patch
Patch3006: cscope-7-fscanner-swallow-function-as-parameters.patch
Patch3007: cscope-8-emacs-plugin-fixup-GNU-Emacs-27.1-removes-function-p.patch

BuildRequires: gcc pkgconfig ncurses-devel flex bison m4 autoconf automake make
Requires: emacs-filesystem coreutils ed

%description
cscope is a mature, ncurses based, C source code tree browsing tool.  It allows users to search large
source code bases for variables, functions, macros, etc, as well as perform general regex and plain
text searches. Results are returned in lists, from which the user can select individual matches for
use in file editing.

%prep
%autosetup -n %{name}-%{version} -p1

%build
autoreconf
%configure
%make_build

%install
rm -rf %{buildroot} %{name}-%{version}.files
make DESTDIR=%{buildroot} install 
mkdir -p %{buildroot}/var/lib/cs
install -Dp contrib/xcscope/xcscope.el %{buildroot}%{cscope_share_path}/xcscope.el
cp -a contrib/cctree.vim %{buildroot}%{cscope_share_path}

install -m 755 contrib/xcscope/cscope-indexer %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{emacs_lisp_path}
ln -s %{cscope_share_path}/xcscope.el %{buildroot}%{emacs_lisp_path}
touch %{buildroot}%{emacs_lisp_path}/xcscope.elc
echo "%ghost %{emacs_lisp_path}/xcscope.el*" >> %{name}-%{version}.files

%triggerin -- emacs, emacs-nox, emacs-lucid
ln -sf %{cscope_share_path}/xcscope.el %{emacs_lisp_path}/xcscope.el

%triggerin -- vim-filesystem
ln -sf %{cscope_share_path}/cctree.vim %{vim_plugin_path}/cctree.vim

%triggerun -- emacs, emacs-nox, emacs-lucid
[ $2 -gt 0 ] && exit 0
rm -f %{emacs_lisp_path}/xcscope.el

%triggerun -- vim-filesystem
[ $2 -gt 0 ] && exit 0
rm -f %{vim_plugin_path}/cctree.vim

%files -f %{name}-%{version}.files
%license COPYING
%doc AUTHORS ChangeLog README TODO contrib/cctree.txt
%{_bindir}/*
%dir %{cscope_share_path}
%{cscope_share_path}/
%dir /var/lib/cs
%{_mandir}/man1/*

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.9-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.9-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.9-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.9-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.9-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Jan 31 2023 Shuo Wang <abushwang@tencent.com> - 15.9-1
- initial build

